# PSF-LoginServer - master - net.psforever.objects.serverobject.generator.GeneratorControl
PSF - LoginServer - master - net.psforever.objects.serverobject.generator.GeneratorControl
Keywords: PSF LoginServer master net.psforever.objects.serverobject.generator.GeneratorControl

PSF-LoginServer - master < Back


# Packages

-  package root
  Definition Classes
    root
-  package net
  Definition Classes
    root
-  package psforever
  Definition Classes
    net
-  package objects
  Definition Classes
    psforever
-  package serverobject
  Definition Classes
    objects
-  package generator
  Definition Classes
    serverobject
- Generator
- GeneratorControl
- GeneratorDefinition

c

net.psforever.objects.serverobject.generator

# GeneratorControl 

###
Companion object GeneratorControl

#### class GeneratorControl extends Actor with Check with DamageableEntity with RepairableEntity with AmenityAutoRepair

An `Actor` that handles messages being dispatched to a specific `Generator`.

Source
  GeneratorControl.scala

Linear Supertypes
AmenityAutoRepair, NtuStorageBehavior, RepairableEntity, Repairable, DamageableEntity, Damageable, Check, BasicAffinity, Actor, AnyRef, Any

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. GeneratorControl
2. AmenityAutoRepair
3. NtuStorageBehavior
4. RepairableEntity
5. Repairable
6. DamageableEntity
7. Damageable
8. Check
9. BasicAffinity
10. Actor
11. AnyRef
12. Any

1. Hide All
2. Show All

Visibility

1. Public
2. Protected

### Instance Constructors

1.  new GeneratorControl(gen: Generator)

   gen

     the `Generator` object being governed

### Type Members

1.  type Receive = PartialFunction[Any, Unit]
   Definition Classes
     Actor

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##: Int
   Definition Classes
     AnyRef → Any
3.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
4.  def AutoRepairObject: Generator
   Definition Classes
     GeneratorControl → AmenityAutoRepair
5.  def CanBeRepairedByNanoDispenser(player: Player, item: Tool): Unit

   Catch the expected repair message and apply further checks to the combination of the target, the equipment, and tis user.

   Catch the expected repair message and apply further checks to the combination of the target, the equipment, and tis user. If the checks pass, perform the repair.

   player

     the user of the nano dispenser tool

   item

     the nano dispenser tool

   Definition Classes
     RepairableEntity → Repairable
6.  def CanPerformRepairs(obj: Target, player: Player, item: Tool): Boolean

   Test the combination of target entity, equipment user, and the equipment to determine if the repair process attempt would be permitted.

   Test the combination of target entity, equipment user, and the equipment to determine if the repair process attempt would be permitted. It is not necessary to check that the tool and its ammunition are correct types; that test was already performed.
   The target entity must be repairable and have less than full health and, if it is destroyed, must have an object attribute that permits it to be repaired after being destroyed.
   The user must have the same faction affinity as the target entity or be neutral.
   The equipment must have some ammunition.
   The user must be alive and be within a certain distance of the target entity.

   player

     the user of the nano dispenser tool

   item

     the nano dispenser tool

   returns

     `true`, if the target entity can be repaired; `false`, otherwise

   Attributes
     protected
   Definition Classes
     GeneratorControl → RepairableEntity
   See also

     `org.log4s.getLogger`

     `PlanetSideEmpire`

     `Vector3.Distance`

     `VitalityDefinition`

7.  def DamageAwareness(target: Target, cause: DamageResult, amount: Any): Unit

   What happens when damage is sustained but the target does not get destroyed.

   What happens when damage is sustained but the target does not get destroyed.

   target

     the entity being damaged

   cause

     historical information about the damage

   amount

     the amount of damage

   Attributes
     protected
   Definition Classes
     GeneratorControl → DamageableEntity
8.  def DamageLog(target: Target, msg: String): Unit

   Log a damage message with a decorator for this target.

   Log a damage message with a decorator for this target. The decorator is constructed by the `Actor` name of the entity, sliced after the last forward/slash. For example, for "foo/bar/name", the decorator is just "name".

   target

     the entity to be used for the decorator

   msg

     the message for the damage log

   Attributes
     protected
   Definition Classes
     DamageableEntity
   See also

     `PlanetSideServerObject`

9.  def DamageLog(msg: String): Unit

   Log a damage message.

   Log a damage message.

   msg

     the message for the damage log

   Attributes
     protected
   Definition Classes
     DamageableEntity
10.  def DamageableObject: Generator

    Contextual access to the object being the target of this damage.

    Contextual access to the object being the target of this damage. Needs declaration in lowest implementing code.

    returns

      the entity controlled by this actor

    Definition Classes
      GeneratorControl → Damageable
11.  def DestructionAwareness(target: Target, cause: DamageResult): Unit

    What happens when the target sustains too much damage and is destroyed.

    What happens when the target sustains too much damage and is destroyed.

    target

      the entity being destroyed

    cause

      historical information about the damage

    Attributes
      protected
    Definition Classes
      GeneratorControl → DamageableEntity
    See also

      `Damageable.DestructionAwareness`

12.  def FactionObject: Generator
    Definition Classes
      GeneratorControl → BasicAffinity
13.  def HandleDamage(target: Target, cause: DamageResult, damage: Any): Unit

    Select between mere damage reception or target destruction.

    Select between mere damage reception or target destruction.

    target

      the entity being damaged

    cause

      historical information about the damage

    damage

      the amount of damage

    Attributes
      protected
    Definition Classes
      DamageableEntity
    See also

      `VitalDefinition.DamageDestroysAt`

14.  def HandleNtuGrant(sender: ActorRef, src: NtuContainer, amount: Float): Unit

    When reports of an NTU provision is returned to the requesting amenity, the amount of repair that can be performed is obtained and, if the amenity still requires those repairs, auto-repair executes a single tick.

    When reports of an NTU provision is returned to the requesting amenity, the amount of repair that can be performed is obtained and, if the amenity still requires those repairs, auto-repair executes a single tick.

    Definition Classes
      AmenityAutoRepair → NtuStorageBehavior
    See also

      `RepairableAmenity`

15.  def HandleNtuOffer(sender: ActorRef, src: NtuContainer): Unit
    Definition Classes
      AmenityAutoRepair → NtuStorageBehavior
16.  def HandleNtuRequest(sender: ActorRef, min: Float, max: Float): Unit
    Definition Classes
      AmenityAutoRepair → NtuStorageBehavior
17.  def NtuStorageObject: NtuContainer
    Definition Classes
      NtuStorageBehavior
18.  def PerformDamage(target: Target, applyDamageTo: Output): Unit

    Assess the vital statistics of the target, apply the damage, and determine if any of those statistics changed.

    Assess the vital statistics of the target, apply the damage, and determine if any of those statistics changed. By default, only take an interest in the change of "health". If implementing custom `DamageableAmenity` with no new message handling, choose to override this method.

    target

      the entity to be damaged

    applyDamageTo

      the function that applies the damage to the target in a target-tailored fashion

    Attributes
      protected
    Definition Classes
      DamageableEntity → Damageable
    See also

      `DamageableAmenity.TakesDamage`

      `ResolutionCalculations.Output`

      `Vitality.Health`

19.  def PerformRepairs(target: Target, amount: Int): Int
    Definition Classes
      GeneratorControl → RepairableEntity
20.  def PerformRepairs(target: Target, player: Player, item: Tool): Unit

    Calculate the health points change and enact that repair action if the targets are stationary.

    Calculate the health points change and enact that repair action if the targets are stationary. Restore the target entity to a not destroyed state if applicable. Always show the repair progress bar window by using the appropriate packet.

    target

      the entity being repaired

    player

      the user of the nano dispenser tool

    item

      the nano dispenser tool

    Attributes
      protected
    Definition Classes
      RepairableEntity
    See also

      `AvatarAction.PlanetsideAttributeToAll`

      `AvatarAction.SendResponse`

      `AvatarService`

      `InventoryStateMessage`

      `PlanetSideGameObject.isMoving`

      `RepairMessage`

      `Service.defaultPlayerGUID`

      `Tool.Discharge`

      `Zone.AvatarEvents`

21.  def RepairToolValue(item: Tool): Float

    The amount of repair that any specific tool provides.

    The amount of repair that any specific tool provides.

    item

      the tool in question

    returns

      an amount to add to the repair attempt progress

    Definition Classes
      Repairable
    See also

      `Repairable.Quality`

22.  def RepairableObject: Generator

    Contextual access to the object being the target of this damage.

    Contextual access to the object being the target of this damage. Needs declaration in lowest implementing code.

    returns

      the entity controlled by this actor

    Definition Classes
      GeneratorControl → Repairable
23.  def Restoration(obj: Target): Unit

    The entity is no longer destroyed.

    The entity is no longer destroyed.

    obj

      the entity

    Definition Classes
      GeneratorControl → Repairable
24.  def StopNtuBehavior(sender: ActorRef): Unit

    Stop the auto-repair timer.

    Stop the auto-repair timer.

    Definition Classes
      AmenityAutoRepair → NtuStorageBehavior
25.  def WillAffectTarget(target: Target, damage: Int, cause: DamageResult): Boolean

    Does the damage or the projectile that caused the damage offer any reason to execute the reminder of damage resolution considerations? The projectile causing additional affects, e.g., jamming, should be tested here, when applicable.

    Does the damage or the projectile that caused the damage offer any reason to execute the reminder of damage resolution considerations? The projectile causing additional affects, e.g., jamming, should be tested here, when applicable. Contrast with `Vitality.CanDamage`. The damage value tested against should be the total value of all meaningful vital statistics affected.

    target

      the entity to be damaged

    damage

      the amount of damage

    cause

      historical information about the damage

    returns

      `true`, if damage resolution is to be evaluated; `false`, otherwise

    Attributes
      protected
    Definition Classes
      GeneratorControl → DamageableEntity
    See also

      `Damageable.CanDamageOrJammer`

      `PerformDamage`

26.  final def actuallyTryAutoRepair(): Boolean

    Attempt to start auto-repair operation only if no operation is currently being processed.

    Attempt to start auto-repair operation only if no operation is currently being processed. In case that an override to the normals operations of `tryAutoRepair` is necessary, but the superclass can not be invoked, this method is the backup of those operations to initiate auto-repair.

    returns

      `true`, if the auto-repair process started specifically due to this call; `false`, if it was already started, or did not start

    Definition Classes
      AmenityAutoRepair
    See also

      `tryAutoRepair`

27.  var alarmCooldown: Cancellable

    when damaged, announce that damage was dealt on a schedule

28.  def aroundPostRestart(reason: Throwable): Unit
    Attributes
      protected[akka]
    Definition Classes
      Actor
    Annotations
      @InternalApi()
29.  def aroundPostStop(): Unit
    Attributes
      protected[akka]
    Definition Classes
      Actor
    Annotations
      @InternalApi()
30.  def aroundPreRestart(reason: Throwable, message: Option[Any]): Unit
    Attributes
      protected[akka]
    Definition Classes
      Actor
    Annotations
      @InternalApi()
31.  def aroundPreStart(): Unit
    Attributes
      protected[akka]
    Definition Classes
      Actor
    Annotations
      @InternalApi()
32.  def aroundReceive(receive: akka.actor.Actor.Receive, msg: Any): Unit
    Attributes
      protected[akka]
    Definition Classes
      Actor
    Annotations
      @InternalApi()
33.  final def asInstanceOf[T0]: T0
    Definition Classes
      Any
34.  final val autoRepairBehavior: Receive
    Definition Classes
      AmenityAutoRepair
35.  final val canBeRepairedByNanoDispenser: akka.actor.Actor.Receive

    The official mixin hook; `orElse` onto the "control" `Actor` `receive`; catch the expected repair message and apply initial checks to the item

    The official mixin hook; `orElse` onto the "control" `Actor` `receive`; catch the expected repair message and apply initial checks to the item

    Definition Classes
      Repairable
    See also

      `Ammo`

      `CanBeRepairedByNanoDispenser`

      `CommonMessages.Use`

      `GlobalDefinitions`

      `Tool.AmmoType`

36.  val checkBehavior: Receive
    Definition Classes
      Check
37.  def clone(): AnyRef
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.CloneNotSupportedException]) @native()
38.  val commonBehavior: Receive

    behavior that is valid for both "with-ntu" and "without-ntu"

39.  implicit val context: ActorContext
    Definition Classes
      Actor
40.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
41.  def equals(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef → Any
42.  lazy val explosionFunc: (PlanetSideGameObject, PlanetSideGameObject, Float) => Boolean

    the canned explosion used by this generator

43.  def finalize(): Unit
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
44.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
45.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
46.  var imminentExplosion: Boolean

    flagged to explode after some time

47.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
48.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
49.  def noNtuSupplyCallback(): Unit

    No (further) provisions of NTU to the potential requesting amenity will be forthcoming.

    No (further) provisions of NTU to the potential requesting amenity will be forthcoming. Cancel any attempts at auto-repair.

    Definition Classes
      GeneratorControl → AmenityAutoRepair
50.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
51.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
52.  final val originalTakesDamage: akka.actor.Actor.Receive

    a duplicate of the core implementation for the default mixin hook, for use in overriding

    a duplicate of the core implementation for the default mixin hook, for use in overriding

    Definition Classes
      Damageable
53.  def postRestart(reason: Throwable): Unit
    Definition Classes
      Actor
    Annotations
      @throws(classOf[java.lang.Exception])
54.  def postStop(): Unit
    Definition Classes
      Actor
    Annotations
      @throws(classOf[java.lang.Exception])
55.  def preRestart(reason: Throwable, message: Option[Any]): Unit
    Definition Classes
      Actor
    Annotations
      @throws(classOf[java.lang.Exception])
56.  def preStart(): Unit
    Definition Classes
      Actor
    Annotations
      @throws(classOf[java.lang.Exception])
57.  var queuedExplosion: Cancellable

    explode when this timer completes

58.  def receive: Receive
    Definition Classes
      GeneratorControl → Actor
59.  implicit final val self: ActorRef
    Definition Classes
      Actor
60.  final def sender(): ActorRef
    Definition Classes
      Actor
61.  final def stopAutoRepair(): Unit

    Cancel any attempts at auto-repair by stopping any currently processing repair timer The operation can be resumed.

    Cancel any attempts at auto-repair by stopping any currently processing repair timer The operation can be resumed.

    Definition Classes
      AmenityAutoRepair
    See also

      `stopAutoRepairFunctionality`

62.  def storageBehavior: Receive
    Definition Classes
      NtuStorageBehavior
63.  def supervisorStrategy: SupervisorStrategy
    Definition Classes
      Actor
64.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
65.  val takesDamage: akka.actor.Actor.Receive

    the official mixin hook; `orElse` onto the "control" `Actor` `receive`; or, cite the `originalTakesDamage` protocol during inheritance overrides

    the official mixin hook; `orElse` onto the "control" `Actor` `receive`; or, cite the `originalTakesDamage` protocol during inheritance overrides

    Definition Classes
      Damageable
66.  def toString(): String
    Definition Classes
      AnyRef → Any
67.  def tryAutoRepair(): Boolean

    Attempt to start auto-repair operation only if no operation is currently being processed.

    Attempt to start auto-repair operation only if no operation is currently being processed.

    returns

      `true`, if the auto-repair process started specifically due to this call; `false`, if it was already started, or did not start

    Definition Classes
      AmenityAutoRepair
    See also

      `actuallyTryAutoRepair`

68.  def unhandled(message: Any): Unit
    Definition Classes
      Actor
69.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
70.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
71.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()
72.  def withNtu: Receive
73.  def withNtuSupplyCallback(): Unit

    Confirm that a provision of NTU to the potential requesting amenity is possible.

    Confirm that a provision of NTU to the potential requesting amenity is possible. Attempt to start auto-repair operations.

    Definition Classes
      GeneratorControl → AmenityAutoRepair
74.  def withoutNtu: Receive

### Inherited from AmenityAutoRepair

### Inherited from NtuStorageBehavior

### Inherited from RepairableEntity

### Inherited from Repairable

### Inherited from DamageableEntity

### Inherited from Damageable

### Inherited from Check

### Inherited from BasicAffinity

### Inherited from Actor

### Inherited from AnyRef

### Inherited from Any

### Ungrouped